class Bar{
  int sizeX;
  int sizeY;
  int posX;
  int posY;
  
  int max;
  float progress;
  
  PVector colour;
  
  String text;
  
  boolean complete = false;
  
  Bar(int PosX, int PosY, int SizeX, int SizeY, int Max, PVector Colour, String Text){
    posX = PosX;
    posY = PosY;
    sizeX = SizeX;
    sizeY = SizeY;
    max = Max;
    colour = Colour;
    text = Text;
  }
  
  void update(){
    rectMode(CORNER);
    drawBase();
    drawProgress();
    displayText();
    if(progress >= max){
      complete = true;
    }
  }
  
  
  void drawBase(){
    fill(0);
    rect(posX, posY, sizeX, sizeY);
  }
  
  void drawProgress(){
    fill(colour.x, colour.y, colour.z);
    rect(posX, posY, progress * (float(sizeX)/float(max)), sizeY);
  }
  
  void displayText(){
    fill(255);
    textSize(45);
    text(text, posX + sizeX/2, posY + sizeY/1.4);
  }
}

class TimeBar extends Bar{
  int baseTime;
  int time;
  
  TimeBar(int PosX, int PosY, int SizeX, int SizeY, int Max, PVector Colour, String Text){
    super(PosX, PosY, SizeX, SizeY, Max, Colour, Text);
  }
  
  void update(){
    super.update();
    progress = (millis() - baseTime)/max;
    time = millis();
    
  }
}

class ProgressBar extends Bar{
  float intactObjects;
  
  ProgressBar(int PosX, int PosY, int SizeX, int SizeY, int Max, PVector Colour, String Text){
    super(PosX, PosY, SizeX, SizeY, Max, Colour, Text);
    
    max = puzzleObjects.size();
    
    for(int i = 0; i < puzzleObjects.size(); i++){
      if(puzzleObjects.get(i).natualState){
        intactObjects += 1;
      }
    }
  }
  
  void update(){
    super.update();
    
    
    progress = (intactObjects/puzzleObjects.size());
    if(progress < 0.3){
      colour = red;
    }
    else if(progress < 0.6){
      colour = orange;
    }
    else{
      colour = green;
    }
  }
  
  void displayText(){
    fill(255);
    textSize(40);
    text(text + int(progress*100) + "%", posX + sizeX/2, posY + sizeY/1.4);
  }
  
  void drawProgress(){
    fill(colour.x, colour.y, colour.z);
    rect(posX, posY, progress * sizeX, sizeY);
  }
}
