class Human{
  
  //tutorial stuff
  boolean usedDoors = false;
  boolean boolIsHiding = false;
  
  int posX = 280;
  int posY = 705;
  int backgroundColor = 255;

  boolean justTeleported = false;
  boolean isWalking = false;
  boolean isHiding = false;
  boolean right = true;
  
  int targetX = mouseX;
  int targetY = mouseY;
  
  int doorX;
  
  int previousTime = 0;
  int frame = 0;
  
  GameObject targetObject;
  Door door;
  PuzzleObject object;
  HideObject hideObject;
  Room room;
  
  float anxiety = 0;
  float walkSpeed = 5;
  
  PImage displayImage;
  PImage idleLeft;
  PImage idleRight;
  PImage scaredLeft;
  PImage scaredRight;
  PImage[] walkLeft;
  PImage[] walkRight;
  PImage[] walkLeftScared;
  PImage[] walkRightScared;
  SpriteSheet sheet;
  
  Human(int PosX, int PosY, PImage IdleLeft, PImage IdleRight, PImage WalkLeft, PImage WalkRight, PImage ScaredLeft, PImage ScaredRight, PImage WalkLeftScared, PImage WalkRightScared){
    posX = PosX;
    posY = PosY;
    
    idleLeft = IdleLeft;
    idleRight = IdleRight;
    scaredLeft = ScaredLeft;
    scaredRight = ScaredRight;
    
    sheet = new SpriteSheet(WalkLeft, 2, 1);
    walkLeft = sheet.images;
    
    sheet = new SpriteSheet(WalkRight, 2, 1);
    walkRight = sheet.images;
    
    sheet = new SpriteSheet(WalkLeftScared, 2, 1);
    walkLeftScared = sheet.images;
    
    sheet = new SpriteSheet(WalkRightScared, 2, 1);
    walkRightScared = sheet.images;
  }
  
  void update(){
    if(!isHiding){
      if(isWalking){
        if(anxiety < ghostFollowAnxiety){
          if(right){
            animate(walkRight);
          }
          else{
            animate(walkLeft);
          }
        }
        else{
          if(right){
            animate(walkRightScared);
          }
          else{
            animate(walkLeftScared);
          }
        }
      }
      else{
        if(anxiety < ghostFollowAnxiety){
          if(right){
            image(idleRight, posX, posY, 170, 170);
          }
          else{
            image(idleLeft, posX, posY, 170, 170);
          }
        }
        else{
          if(right){
            image(scaredRight, posX, posY, 170, 170);
          }
          else{
            image(scaredLeft, posX, posY, 170, 170);
          }
        }
      }
    }
    
    
    walk();
    
    handelAnxiety();
  }
  
  
  void walk(){
    if(click && !puzzleActive){
      click = false;
      mouseInput(mouseX, mouseY);
    }
    
    if(isWalking){
      
      if(targetX < posX){
        right = false;
      }
      else{
        right = true;
      }
      
      doorCheck();
      puzzleCheck();
      hideCheck();
      posX += (posX < targetX) ? 1 * walkSpeed : -1 * walkSpeed;
        
      if(abs(posX - targetX) < 4){
        isWalking = false;
      }
    }
  }
  
  
  void animate(PImage[] anim){
    if(millis() > previousTime + 400){
      if(frame < 1){
        frame++;
      }
      else{
        frame = 0;
      }
      previousTime = millis();
    }
    image(anim[frame], posX, posY, 170, 170); 
  }
  
  void doorCheck(){
    for(int i = 0; i < doors.size(); i++){
      if(doors.get(i).target){
        targetObject = doors.get(i);
        door = doors.get(i);
        if(steps < 5 && !door.tutorialInteractable){
          if(steps == 2){
            tutorialDontInteract(door);
          }
        }
        else{
          if(posX > doors.get(i).posX  - 50 && posX < doors.get(i).posX + 50 && posY > doors.get(i).posY - 115 && posY < doors.get(i).posY + 115){
            posX = doors.get(i).targetX;
            posY = doors.get(i).targetY;
            doors.get(i).target = false;
            isWalking = false;
            door.goIn();
            for(int j = 0; j < doors.size(); j++){
              if(new PVector(doors.get(j).posX, doors.get(j).posY).dist(new PVector(posX, posY)) < new PVector(door.posX, door.posY).dist(new PVector(posX, posY))){
                door = doors.get(j);
                
              }
            }
            door.goOut();
            door.target = false;
            door = null;
          }
        }
      }
    }  
  }
  
  void puzzleCheck(){
    for(int i = 0; i < puzzleObjects.size(); i++){
      if(puzzleObjects.get(i).target){
        targetObject = puzzleObjects.get(i);
        object = puzzleObjects.get(i);
        if(steps < 5 && !puzzleObjects.get(i).tutorialInteractable){
          if(steps == 2){
            tutorialDontInteract(targetObject);
          }
        }
        else{
          if(posX > object.posX  - 30 && posX < object.posX + 30  && posY > object.posY - 115 && posY < object.posY + 200){
            object.activatePuzzle();
            object.target = false;
            isWalking = false;
          }
        }
      }
    } 
  }
  
  void hideCheck(){
    for(int i = 0; i < hideObjects.size(); i++){
      if(hideObjects.get(i).target){
        targetObject = hideObjects.get(i);
        hideObject = hideObjects.get(i);
        if(posX > hideObject.posX - 30 && posX < hideObject.posX + 30 && posY > hideObject.posY - 115 && posY < hideObject.posY + 200){
          hideObject.hide();
          hideObject.target = false;
          isWalking = false;
          
        }
      }
    } 
  }
  
  void tutorialDontInteract(GameObject tutObject){
    tutObject.target = false;
    if(!thisNotHelp.isPlaying()){
      thisNotHelp.play();
    }
  }
  
  boolean humanInRoomCheck(){
    for(int i = 0; i < rooms.size(); i++){
      if(rooms.get(i).humanIn){
        room = rooms.get(i);
          if(targetX > rooms.get(i).posX + rooms.get(i).sizeX/2 || targetX < rooms.get(i).posX - rooms.get(i).sizeX/2 || targetY > rooms.get(i).posY + rooms.get(i).sizeY/2 || targetY < rooms.get(i).posY - rooms.get(i).sizeY/2){
            return false;
          }
      }
    }
    return true;
  }
  
  void mouseInput(int TargetX, int TargetY){
    if(steps >= 2){
      targetX = TargetX;
      targetY = TargetY;
      
      if(targetObject != null && !targetObject.mouseOver){
        targetObject.target = false;
        targetObject = null;
      }
      
      if(humanInRoomCheck()){
        if(isHiding){
          hideObject.natualState = true;
          isHiding = false;
        }
        isWalking = true;
      }
      else{
        isWalking = false;
        targetX = posX;
        for(int i = 0; i < doors.size(); i++){
          doors.get(i).target = false;
        }
      }
    }
  }
  
  void handelAnxiety(){
    if(anxiety > 0){
      anxiety -= 0.25;
      if(isHiding){
        anxiety -= 0.75;
      }
    }
  }
}
