class InteractableObject extends GameObject{
  PImage displayImage;
  
  boolean natualState = false;
  
  InteractableObject(PImage Image, int PosX, int PosY, int SizeX, int SizeY, boolean NatualState){
    super(Image, PosX, PosY, SizeX, SizeY);
    
    displayImage = Image;
    natualState = NatualState;
  }
  
  void update(){
    super.update();
    
    displayState();
      
    if(click == true && mouseIn() == true && !puzzleActive){
      clickedOn();
    }
  }
  
  void clickedOn(){
    if(!human.isHiding){
      click = false;
      target = true;
      human.mouseInput(posX, posY);
    }
  }
  
  
  void displayState(){
    if(natualState){
      image = null;
    }
    else{
      image = displayImage;
    }
  }
}



class PuzzleObject extends InteractableObject{
  boolean tutorialInteractable;
  
  PImage puzzleImage;
  PImage buttonImage;
  boolean NatualState = false;
  
  boolean puzzleActivated = false;
  boolean thisPuzzleActive = false;
  
  Puzzle puzzle;
  
  PuzzleObject(PImage Image, int PosX, int PosY, int SizeX, int SizeY, boolean NatualState, boolean TutorialInteractable){
    super(Image, PosX, PosY, SizeX, SizeY, NatualState);
    puzzle = puzzles.get(puzzles.size() - 1);
    puzzle.task = this;
    
    tutorialInteractable = TutorialInteractable;
  }
  
  void activatePuzzle(){
    if(!natualState){
      click = false;
      
      if(!puzzleActivated){
        puzzleActivated = true;
      }
      thisPuzzleActive = true;
      puzzleActive = true;
    }
  }
  
  void displayState(){
    if(!natualState){
      image = null;
    }
    else{
      image = displayImage;
    }
  }
  
  void sabotage(){
    natualState = false;
    puzzle.sabotage();
  }
}



class HideObject extends InteractableObject{
  PImage full;
  
  HideObject(PImage Image, int PosX, int PosY, int SizeX, int SizeY){
    super(Image, PosX, PosY, SizeX, SizeY, true);
    full = Image;
  }
  
  void clickedOn(){
    
    if(!natualState){
      natualState = true;
      human.isHiding = false;
      human.posX = posX;
    }
    else if(!human.isHiding){
      click = false;
      target = true;
      human.mouseInput(posX, posY);
    }
  }
  
  void hide(){
    natualState = false;
    human.isHiding = true;
  }
}
