import processing.sound.*;

SoundFile shouldBoiler;
SoundFile ohNoGhost;
SoundFile inCloset;
SoundFile hopeMoreCloset;
SoundFile thisNotHelp;
ArrayList<GameObject> objects = new ArrayList();
ArrayList<Room> rooms = new ArrayList();
ArrayList<Door> doors = new ArrayList();
ArrayList<PuzzleObject> puzzleObjects = new ArrayList();
ArrayList<HideObject> hideObjects = new ArrayList();
ArrayList<Puzzle> puzzles = new ArrayList();


Puzzle puzzle;
int steps = 5;

PImage background;
PImage fullImage;
PImage backgroundNoHighlight;
PImage backgroundToBoiler;
PImage backgroundToWardrobe;

PImage buttonImage;

PImage poster;
PImage winImage;
PImage lossImage;
PImage gameOverImage;

//colours for bars
PVector green = new PVector(20, 209, 0);
PVector orange = new PVector(250, 167, 0);
PVector red = new PVector(165, 17, 0);

int gameTime = 240;
//int gameTime = 2;
int ghostFollowAnxiety = 10;

ProgressBar progressBar;
Bar anxietyBar;
Bar timeBar;
Button resetButton;

Human human;

Ghost ghost;

Timer timer;

boolean tutorialActive = false;

boolean canClick = true;
boolean click = false;
boolean mouseDown = false;

boolean puzzleActive = false;

boolean startMenu = true;
boolean actualDrawActive = false;
boolean gameOverActive = false;

void setup(){
  textAlign(CENTER);
  frameRate(30);
  size(1920, 1080);
  
  
  
  shouldBoiler = new SoundFile(this, "ShouldFixBoiler.wav");
  ohNoGhost = new SoundFile(this, "OhNoGhost.wav");
  inCloset = new SoundFile(this, "InCloset.wav");
  hopeMoreCloset = new SoundFile(this, "HopeMoreCloset.wav");
  thisNotHelp = new SoundFile(this, "ThisNotHelp.wav");
  
  buttonImage = loadImage("QuitButton.png");
  
  fullImage = loadImage("Background.png");
  background = fullImage;
  
  poster = loadImage("Poster.png");
  
  backgroundNoHighlight = loadImage("BackgroundNoHighlight.png");
  backgroundToBoiler = loadImage("BackgroundToBoiler.png");
  backgroundToWardrobe = loadImage("BackgroundToWardrobe.png");
  
  ghost = new Ghost(630, 900,loadImage("Ghost.png"), loadImage("GhostLookRight.png"), loadImage("GhostLeft.png"), loadImage("GhostRight.png"), loadImage("GhostDestroyLeft.png"), loadImage("GhostDestroyRight.png"));
  human = new Human(280, 705, loadImage("PlayerIdle.png"), loadImage("PlayerIdleRight.png"), loadImage("PlayerWalkLeft.png"), loadImage("PlayerWalkRight.png"), loadImage("PlayerScaredLeft.png"), loadImage("PlayerScaredRight.png"), loadImage("PlayerWalkLeftScared.png"), loadImage("PlayerWalkRightScared.png"));
  
  timer = new Timer();
  
  winImage = loadImage("WinScreen.png");
  lossImage = loadImage("LossScreen.png");
  resetButton = new Button(loadImage("RestartButton.png"), width/2 + 200, height/2 + 250, 700, 700);
  
  rooms.add(new Room("floor 1 - left", 850, 150, 650, 250));
  rooms.add(new Room("floor 1 - right", 1460, 150, 520, 250));
  rooms.add(new Room("floor 2 - left", 840, 420, 800, 250));
  rooms.add(new Room("floor 2 - right", 1540, 420, 550, 250));
  rooms.add(new Room("floor 3 - left", 350, 690, 580, 250));
  rooms.add(new Room("floor 3 - middle", 970, 690, 620, 250));
  rooms.add(new Room("floor 3 - right", 1580, 690, 550, 250));
  rooms.add(new Room("floor 4 - middle", 980, 950, 750, 230));
  
  
  
  
  PImage FrontIn = loadImage("FrontDoorIn.png");
  PImage FrontOut = loadImage("FrontDoorOut.png");
  PImage RightIn = loadImage("SideDoorRightIn.png");
  PImage RightOut = loadImage("SideDoorRightOut.png");
  PImage LeftIn = loadImage("SideDoorLeftIn.png");
  PImage LeftOut = loadImage("SideDoorLeftOut.png");
  //door floor 1 left - going to floor 2
  doors.add(new Door(FrontIn, FrontOut, 657, 140, 75, 110, 665, 435, human, false));
  //door floor 1 left - going to right
  doors.add(new Door(LeftIn, LeftOut, 1155, 140, 40, 150, 1260, 165, human, false));
  //door floor 1 right - going to left
  doors.add(new Door(RightIn, RightOut, 1215, 140, 40, 150, 1115, 165, human, false));

  //door floor 2 left - going to floor 1 
  doors.add(new Door(FrontIn, FrontOut, 650, 395, 80, 110, 655, 165, human, false));
  //door floor 2 left - going to floor 3
  doors.add(new Door(FrontIn, FrontOut, 765, 395, 80, 110, 770, 705, human, false));
  //door floor 2 left - going to right
  doors.add(new Door(LeftIn, LeftOut, 1210, 410, 50, 140, 1310, 435, human, false));
  //door floor 2 right - going to left
  doors.add(new Door(RightIn, RightOut, 1275, 405, 50, 145, 1180, 435, human, false));

  //door floor 3 left - going to middle
  doors.add(new Door(LeftIn, LeftOut, 620, 680, 47, 150, 710, 705, human, true));
  //door floor 3 middle - going to left
  doors.add(new Door(RightIn, RightOut, 675, 680, 50, 150, 585, 705, human, false));
  //door floor 3 middle - going to floor 2
  doors.add(new Door(FrontIn, FrontOut, 770, 665, 80, 110, 760, 435, human, false));
  //door floor 3 middle - going right
  doors.add(new Door(LeftIn, LeftOut, 1265, 680, 50, 150, 1365, 705, human, false));
  //door floor 3 right - going to middle
  doors.add(new Door(RightIn, RightOut, 1325, 680, 50, 150, 1225, 705, human, false));
  //door floor 3 - gonig to floor 4
  doors.add(new Door(FrontIn, FrontOut, 1145, 665, 80, 110, 1155, 925, human, true));

  //door floor 4 - going to floor 3
  doors.add(new Door(FrontIn, FrontOut, 1155, 890, 80, 115, 1145, 705, human, true));
  
  PImage help;
  
  puzzles.add(new ClockPuzzle(loadImage("ClockPuzzle.png"), width/2, height/2, 500, 500));
  help = loadImage("Clock.png");
  puzzleObjects.add(new PuzzleObject(help, 1473, 667, help.width, help.height, false, false));
  
  help = loadImage("BoilerPuzzle.png");
  puzzles.add(new BoilerPuzzle(help, width/2, height/2, help.width/2, help.height/2, loadImage("Log1.png"), loadImage("Log2.png"), loadImage("Log3.png"), loadImage("MatchBox.png"), loadImage("Match.png"), loadImage("MatchLit.png")));
  help = loadImage("Boiler.png");
  puzzleObjects.add(new PuzzleObject(help, 761, 918, help.width, help.height, false, true));
  puzzle = puzzles.get(puzzles.size() - 1);
  
  help = loadImage("BathroomPuzzle.png");
  puzzles.add(new BathroomPuzzle(help, width/2, height/2, help.width / 10, help.height, loadImage("Bucket.png")));
  help = loadImage("Bathroom.png");
  puzzleObjects.add(new PuzzleObject(help, 1549, 154, help.width, help.height, true, false));
  
  help = loadImage("Panel.png");
  puzzles.add(new ElectricalPuzzle(help, width/2, height/2, help.width/2, help.height/2, loadImage("BlackSwitches.png"), loadImage("RedSwitches.png")));
  help = loadImage("ElectricalPanel.png");
  puzzleObjects.add(new PuzzleObject(help, 527, 670, help.width, help.height, false, false));
  
  help = loadImage("FlowerPuzzle.png");
  puzzles.add(new PlantPuzzle(help, width/2, height/2, help.width/2, help.height/2, loadImage("WateringCan.png"), loadImage("WateringCanPooring.png")));
  help = loadImage("Plant.png");
  puzzleObjects.add(new PuzzleObject(help, 542, 412, help.width, help.height, false, false));
  
  help = loadImage("KitchenPuzzle.png");
  puzzles.add(new CloggedSink(help, width/2, height/2, help.width, help.height, loadImage("Plunger.png")));
  help = loadImage("Kitchen.png");
  puzzleObjects.add(new PuzzleObject(help, 1558, 423, help.width, help.height, true, false));
  
  
  hideObjects.add(new HideObject(loadImage("PlayerHiding.png"), 1010, 659, 230, 230));
  hideObjects.add(new HideObject(loadImage("PlayerHiding.png"), 1043, 138, 230, 230));
  
  progressBar = new ProgressBar(0, 0, 400, 60, 0, green, "Progress: ");
  anxietyBar = new Bar(0, 60, 400, 60, 200, red, "Anxiety");
  timeBar = new Bar(0, 120, 400, 60, gameTime * 10, green, "Timeleft: ");
}

void draw(){
  if(actualDrawActive){
    actualDraw();
  }
  else if(startMenu){
    imageMode(CENTER);
    image(poster, width/2, height/2 + 450, width, height * 3);
    pushMatrix();
    fill(255);
    strokeWeight(5);
    rectMode(CENTER);
    rect(width/2, 400, 400, 100, 40);
    fill(0);
    textSize(25);
    text("Start with tutorial", width/2, 410);
    
    fill(255);
    strokeWeight(5);
    rectMode(CENTER);
    rect(width/2, 600, 400, 100, 40);
    fill(0);
    textSize(25);
    text("Start without tutorial", width/2, 610);
    popMatrix();
    strokeWeight(1);
    
    if(startMenu){
      if(mouseX > 760 && mouseX < 1160 && mouseY > 350 && mouseY < 450){
        fill(255,0,0,50);
        rect(width/2, 400, 400, 100, 40);
        if(click){
          steps = 0;
          actualDrawActive = true;
          tutorialActive = true;
          startMenu = false;
          click = false;
        }
      }
      else if(mouseX > 760 && mouseX < 1160 && mouseY > 550 && mouseY < 650){
        fill(255,0,0,50);
        rect(width/2, 600, 400, 100, 40);
        if(click){
          steps = 5;
          timer.baseTime = millis();
          timer.start = true;
          tutorialActive = false;
          actualDrawActive = true;
          startMenu = false;
          click = false;
        }
      }   
    }

  }
  else{
    gameOverLoop();
  }
  
  click = false;
}

void actualDraw(){
  //println(mouseX + " " + mouseY);
  
  if(frameRate < 20){
    println("framerate dip");
    println(frameRate);
  }
  //clear();
  
  imageMode(CORNER);
  for(int i = 0; i < rooms.size(); i++){
    rooms.get(i).update();
  }
  
  imageMode(CENTER);
  
  image(background, width/2, height/2);
  
  for(int i = 0; i < doors.size(); i++){
    doors.get(i).update();
  }
  
  
  for(int i = 0; i < puzzleObjects.size(); i++){
    puzzleObjects.get(i).update();
  }
  for(int i = 0; i < hideObjects.size(); i++){
    hideObjects.get(i).update();
  }
  
  if(steps >= 3){
    ghost.update();
  }
  human.update();
  
  if(puzzleActive){
    for(int i = 0; i < puzzles.size(); i++){
      if(puzzles.get(i).task.thisPuzzleActive){
        puzzles.get(i).update();
      }
    }
  }
  
  progressBar.update();
  anxietyBar.progress = human.anxiety;
  anxietyBar.update();
  if(anxietyBar.complete){
    gameOver(false);
  }
  
  if(progressBar.intactObjects == puzzleObjects.size() && human.anxiety < 10){
    progressBar.progress = 1;
    gameOver(true);
  }
  
  timer.update();
  
  if(steps < 5){
    tutorial();
  }
  
  if(human.isHiding && tutorialActive){
    pushMatrix();
    fill(255, 120);
    strokeWeight(3);
    rectMode(CORNER);
    rect(30, 200, 360, 290);

    /*
    fill(0);
    textSize(35);
    textMode(CORNER);
    text("tip!", 220, 240);
    */
    fill(0);
    textAlign(CORNER);
    textSize(23);
    text("-hiding helps lower \n your anxiety \n -the ghost keeps hunting \n until your anxiety is gone \n -there is another hiding \n spot in this house \n -reach over 60% before the \n time runs out or reach 100%", 50, 234);
    textAlign(CENTER);
    popMatrix();

  }
  
  click = false;
}




void tutorial(){
  
  if(steps == 0){
    background = backgroundNoHighlight;
    //ghost in room = false (in room script)
    //not able to move (done in human script)
    
    shouldBoiler.play();
    steps += 1;
  }
  else if(steps == 1){
    if(!shouldBoiler.isPlaying()){
      background = backgroundToBoiler;
      steps += 1;
    }
  }
  else if(steps == 2){
    //able to move (done in human script)
    
    if(puzzle.solvedOnce){
      background = backgroundToWardrobe;
      ohNoGhost.play();
      steps += 1;
      //ghost in room = true (in room script)
    }
  }
  else if(steps == 3){
    //(mabye make anxiety not kill you/slower)
    if(human.anxiety > 0){
      human.anxiety -= 0.25;
    }
    
    if(human.isHiding){
    background = backgroundNoHighlight;
      if(!ohNoGhost.isPlaying()){
        background = backgroundNoHighlight;
        inCloset.play();
        steps += 1;
      }
    }
  }
  else if(steps == 4){
    if(!inCloset.isPlaying() && human.anxiety <= 5){
      background = fullImage;
      if(!human.isHiding){
        hopeMoreCloset.play();
        timer.baseTime = millis();
        timer.start = true;
        steps += 1;
      }
    }
  }
}

void gameOver(boolean win){
  puzzleActive = false;
  
  if(win){
    gameOverImage = winImage;
  }
  else{
    gameOverImage = lossImage;
  }
  actualDrawActive = false;
  gameOverActive = true;
}

void gameOverLoop(){
  image(gameOverImage, width/2, height/2 - 150, 1200, 1200);
  resetButton.update();
  if(resetButton.pressed){
    resetButton.pressed = false;
    resetGame();
  }
}

void resetGame(){
  
  
  for(int i = 0; i < puzzleObjects.size(); i++){
    puzzleObjects.get(i).thisPuzzleActive = false;
    puzzleObjects.get(i).puzzle.solvedOnce = false;
    
    if(i != 2){
      puzzleObjects.get(i).natualState = false;
      puzzleObjects.get(i).puzzle.sabotage();
    }
    else{
      puzzleObjects.get(i).natualState = true;
      puzzleObjects.get(i).puzzle.sabotage();
    }
  }
  human.posX = 280;
  human.posY = 705;
  human.targetX = human.posX;
  human.targetY = human.posY;
  human.isWalking = false;
  ghost.posX = 630;
  ghost.posY = 900;
  anxietyBar.complete = false;
  progressBar.complete = false;
  progressBar.intactObjects = 1;
  human.anxiety = 0;
  ghost.destroying = false;
  ghost.closest = null;
  clear();
  timer.t = gameTime;
  startMenu = true;
  actualDrawActive = false;
  gameOverActive = false;
}

void mousePressed()
{
  if(canClick){
    canClick = false;
    click = true;
  }
  mouseDown = true;
}

void mouseReleased(){
  canClick = true;
  mouseDown = false;
}
