class Puzzle extends GameObject{
  Button button;
  
  boolean solvedOnce = false;
  
  PuzzleObject task;
  int posInArray;
  
  int dropOfX;
  int dropOfCutX;
  int dropOfY;
  int dropOfCutY;
  
  Puzzle(PImage Image, int PosX, int PosY, int SizeX, int SizeY){
    super(Image, PosX, PosY, SizeX, SizeY);
    button = new Button(buttonImage, posX + sizeX/2 + 50, posY - sizeY/2 + 50, 100, 100);
  }
  
  void update(){
    super.update();
    button.update();
    
    if(button.pressed){
      puzzleActive = false;
      task.thisPuzzleActive = false;
      
      button.pressed = false;
    }
  }
  
  void puzzleComplete(){
    progressBar.intactObjects += 1;
    task.natualState = true;
    task.puzzleActivated = false;
    task.thisPuzzleActive = false;
    puzzleActive = false;
    solvedOnce = true;
  }
  
  void sabotage(){
    println("puzzle doesn't have as sabotage function");
  }
}



class ClockPuzzle extends Puzzle{
  PVector minuteHandel = new PVector(0.01, -1);
  PVector oldHandel = new PVector(0.01, -1);
  PVector hourHandel = new PVector(0, -1);
  
  float hourDegrees = -90;
  
  boolean isFollowingMouse = false;
  int minuteMag = 80;
  int hourMag = 40;
  
  int baseX = 0;
  int baseY = -89;
  
  ClockPuzzle(PImage Image, int PosX, int PosY, int SizeX, int SizeY){
    super(Image,  PosX, PosY, SizeX, SizeY);
    baseX += posX;
    baseY += posY;
    minuteHandel.setMag(minuteMag);
  }
  
  void update(){
    //println((mouseX-posX) + " " + (mouseY-posY));
    super.update();
    drawHandels();
    
    if(hourDegrees >= 22.5 && hourDegrees <= 52.5 && PVector.angleBetween(minuteHandel, new PVector(0, 1)) < 1.25 && PVector.angleBetween(minuteHandel, new PVector(0, 1)) > 1 && minuteHandel.x > 0){
      puzzleComplete();
    }
    
    if(mouseOverHandel() && click){
      click = false;
      isFollowingMouse = true;
    }
    
    if(isFollowingMouse){
      followMouse();
    }
  }
  
  void followMouse(){
    if(mouseDown){
      minuteHandel = new PVector(-(baseX - mouseX), -(baseY - mouseY));
      minuteHandel.setMag(minuteMag);
      getDirection();
    }
    else{
      isFollowingMouse = false;
    }
  }
  
  void getDirection(){
    if(minuteHandel.x > 0){
      if(oldHandel.y > 0 && minuteHandel.y < 0){directionResult(false);}
      else if(oldHandel.y < 0 && minuteHandel.y > 0){directionResult(true);}
    }
    else if(minuteHandel.x < 0){
      if(oldHandel.y < 0 && minuteHandel.y > 0){directionResult(false);}
      else if(oldHandel.y > 0 && minuteHandel.y < 0){directionResult(true);}
    }
    
    if(minuteHandel.y > 0){
      if(oldHandel.x > 0 && minuteHandel.x < 0){directionResult(true);}
      else if(oldHandel.x < 0 && minuteHandel.x > 0){directionResult(false);}
    }
    else if(minuteHandel.y < 0){
      if(oldHandel.x < 0 && minuteHandel.x > 0){directionResult(true);}
      else if(oldHandel.x > 0 && minuteHandel.x < 0){directionResult(false);}
    }
  }
  
  void directionResult(boolean clockWise){
    oldHandel = minuteHandel;
    if(clockWise){
      hourDegrees += 7.5;
    }
    else{
      hourDegrees -= 7.5;
    }
    
    if(hourDegrees < 0){
      hourDegrees += 360;
    }
    else if(hourDegrees > 360){
      hourDegrees -= 360;
    }
    
    PVector.fromAngle(radians(hourDegrees), hourHandel);
  }
  
  boolean mouseOverHandel(){
    if(new PVector(minuteHandel.x + baseX, minuteHandel.y + baseY).dist(new PVector(mouseX, mouseY)) < 50){
      return true;
    }
    return false;
  }
  
  void drawHandels(){
    strokeWeight(5);
    minuteHandel.setMag(minuteMag);
    line(baseX, baseY, baseX + minuteHandel.x, baseY + minuteHandel.y);
    
    strokeWeight(8);
    hourHandel.setMag(hourMag);
    line(baseX, baseY, baseX + hourHandel.x, baseY + hourHandel.y);
    strokeWeight(1);
  }
  
  void sabotage(){
    if(solvedOnce){
      hourDegrees = 345;
      PVector.fromAngle(radians(hourDegrees), hourHandel);
      minuteHandel = new PVector(-1, 0.7);
      oldHandel = new PVector(-1, 0.7);
    }
    else{
      minuteHandel = new PVector(0.01, -1);
      oldHandel = new PVector(0.01, -1);
      hourHandel = new PVector(0, -1);
  
      hourDegrees = -90;
    }
  }
}



class BoilerPuzzle extends Puzzle{
  ArrayList<Log> logs = new ArrayList();
  int logX = 100;
  int logY = 100;
  
  MatchBox matchBox;
  int matchX = 150;
  int matchY = 150;
  
  int dropOfX = 490;
  int dropOfCutX = 560;
  int dropOfY = 170;
  int dropOfCutY = 240;
  
  int logsIn = 0;
  
  BoilerPuzzle(PImage Image, int PosX, int PosY, int SizeX, int SizeY, PImage Log1, PImage Log2, PImage Log3, PImage MatchBoxImage, PImage MatchImage, PImage MatchLitImage){
    super(Image, PosX, PosY, SizeX, SizeY);
    
    dropOfX = posX - 210;
    dropOfCutX = posX - 50;
    dropOfY = posY;
    dropOfCutY = posY + 100;
    
    logs.add(new Log(Log1, PosX + SizeX/2 - logX/2, PosY + SizeY/2 - logY, Log1.width, Log1.height, this));
    logs.add(new Log(Log2, PosX + SizeX/2 - logX * 2, PosY + SizeY/2 - logY, Log2.width, Log2.height, this));
    logs.add(new Log(Log3, PosX + SizeX/2 - int(logX * 3.5), PosY + SizeY/2 - logY, Log3.width, Log3.height, this));
    matchBox = new MatchBox(MatchBoxImage, PosX + 30 + matchX, PosY + 60, matchX, matchY, this, MatchImage, MatchLitImage);
  }
  
  void update(){
    //println(mouseX-posX + " " + (mouseY - posY));
    
    super.update();
    for(int i = 0; i < logs.size(); i++){
      logs.get(i).update();
    }
    
    if(logsIn >= 3){
      matchBox.update();
      //puzzleComplete();
    }
  }
  
  void sabotage(){
    if(solvedOnce){
      logsIn = 2;
      logs.get(0).toOriginalPos();
      //logs.get(1).toOriginalPos();
      matchBox.match.toOriginalPos();
    }
    else{
      logsIn = 0;
      logs.get(0).toOriginalPos();
      logs.get(1).toOriginalPos();
      logs.get(2).toOriginalPos();
      matchBox.match.toOriginalPos();
    }
  }
}



class BathroomPuzzle extends Puzzle{
  PImage[] images;
  Bucket bucket;
  int bucketX = 100;
  int bucketY = 100;
  
  int dropOfX = 340;
  int dropOfCutX = 500;
  int dropOfY = 50;
  int dropOfCutY = 200;
  
  int waterX = -90;
  int waterCutX = 200;
  int waterY = -200;
  int waterCutY;
  int waterHeightStep = 90;
  
  int waterBuckets = 5;
  int waterLevel = 100;
  int frame = 9;
  
  SpriteSheet sheet;
  
  BathroomPuzzle(PImage Image, int PosX, int PosY, int SizeX, int SizeY, PImage Bucket){
    super(Image, PosX, PosY, SizeX, SizeY);
    sheet = new SpriteSheet(Image, 10, 1);
    images = sheet.images;
    
    image = images[frame];
    
    dropOfX = -252 + posX;
    dropOfCutX = -130 + posX;
    dropOfY = -58 + posY;
    dropOfCutY = 214 + posY;
    
    bucket = new Bucket(Bucket, PosX + SizeX/2 - bucketX/2, PosY + SizeY/2 - bucketY/2, Bucket.width/4, Bucket.height/2, this);
  }
  
  void update(){
    //println((mouseX - posX) + " " + (mouseY - posY));
    super.update();
    
    waterCutY = waterY + (waterHeightStep * waterBuckets);
    
    bucket.update();
    image = images[frame];
    if(waterBuckets == 0 && bucket.isEmpty){
      puzzleComplete();
    }
  }
  
  void sabotage(){
    if(solvedOnce){
      waterBuckets = 3;
      waterLevel = 60;
      frame = 5;
      bucket.toOriginalPos();
    }
    else{
      waterBuckets = 5;
      waterLevel = 100;
      frame = 9;
      bucket.toOriginalPos();
    }
  }
}

class ElectricalPuzzle extends Puzzle{
  RedSwitch redSwitch;
  ArrayList<Switch> blackSwitches = new ArrayList();
  int switchX = 34;
  int switchY = 68;
  
  int switchStartX = -90;
  int switchStartY = 144;
  
  int blackUp = 0;
  
  ElectricalPuzzle(PImage Image, int PosX, int PosY, int SizeX, int SizeY, PImage BlackSwitch, PImage RedSwitch){
    super(Image, PosX, PosY, SizeX, SizeY);
    
    redSwitch = new RedSwitch(RedSwitch, PosX + switchStartX + switchX/2, PosY + switchStartY, switchX, switchY, this);
    for(int i = 1; i <= 5; i++){
      blackSwitches.add(new Switch(BlackSwitch, PosX + switchStartX + switchX*i + switchX/2, PosY + switchStartY, switchX, switchY, this));
    }
  }
  
  void update(){
    println((mouseX - posX) + " " + (mouseY - posY));
    super.update();
    redSwitch.update();
    for(int i = 0; i < blackSwitches.size(); i++){
      blackSwitches.get(i).update();
    }
  }
  
  void sabotage(){
    if(solvedOnce){
      for(int i = 0; i < 3; i++){
        blackSwitches.get(int(random(blackSwitches.size()))).turnOff();
      }
    }
    else{
      for(int i = 0; i < blackSwitches.size(); i++){
        blackSwitches.get(i).turnOff();
      }
    }
  }
}

class PlantPuzzle extends Puzzle{
  WateringCan can;
  
  int dropOfX;
  int dropOfCutX;
  int dropOfY;
  int dropOfCutY;
  
  PlantPuzzle(PImage Image, int PosX, int PosY, int SizeX, int SizeY, PImage WateringCanImage, PImage WateringCanPooringImage){
    super(Image, PosX, PosY, SizeX, SizeY);
    dropOfX = -22 + posX;
    dropOfCutX = 140 + posX;
    dropOfY = -100 + posY;
    dropOfCutY = -15 + posY;
    can = new WateringCan(WateringCanImage, WateringCanPooringImage, posX + 150, posY + 150, WateringCanImage.width/2, WateringCanImage.height/2, this);
  }
  
  void update(){
    //println((mouseX - posX) + " " + (mouseY - posY));
    super.update();
    can.update();
  }
  
  void sabotage(){
    if(solvedOnce){
      can.bar.progress = 0;
      can.bar.max = 50;
      can.bar.complete = false;
      can.toOriginalPos();
    }
    else{
      can.bar.progress = 0;
      can.bar.max = 100;
      can.bar.complete = false;
      can.toOriginalPos();
    }
  }
}

class CloggedSink extends Puzzle{
  
  Plunger plunger; 
  
  int sinkHealth = 0;
  
  CloggedSink(PImage image, int posX, int posY, int sizeX, int sizeY, PImage plungerImage){
  super(image, posX, posY, sizeX, sizeY);
  
  plunger = new Plunger(plungerImage, posX + 20, posY - 150, plungerImage.width/4, plungerImage.height/2, this);
  
  }
  
  void update(){
    //println((mouseX - posX) + " " + (mouseY - posY));
    super.update();
    plunger.update();
  }
  
  void sabotage(){
    if(solvedOnce){
      plunger.sinkHealth = 3;
      plunger.bar.progress = 0;
      plunger.bar.max = 3;
    }
    else{
      sinkHealth = 5;
      plunger.bar.progress = 0;
      plunger.bar.max = 5;
    }
  }
}
