class PuzzleMoveableObject extends GameObject{
  boolean shouldUpdate = true;
  
  boolean selected = false;
  int originalX;
  int originalY;
  
  PuzzleMoveableObject(PImage Image, int PosX, int PosY, int SizeX, int SizeY){
    super(Image, PosX, PosY, SizeX, SizeY);
    originalX = PosX;
    originalY = PosY;
  }
  
  void update(){
    if(shouldUpdate){
      super.update();
      
      stickToMouse();
    }
  }
  
  void stickToMouse(){
    if(click && mouseOver){
      selected = true;
    }
    
    if(mouseDown && selected){
      posX = mouseX;
      posY = mouseY;
    }
    else{
      if(inDropOf()){
        dropOf();
      }
      else{
        selected = false;
        posX = originalX;
        posY = originalY;
      }
    }
  }
  
  void dropOf(){
    print("feck");
  }
  
  boolean inDropOf(){
    return false;
  }
  
  void toOriginalPos(){
    shouldUpdate = true;
    posX = originalX;
    posY = originalY;
  }
}

class Log extends PuzzleMoveableObject{
  BoilerPuzzle parent;
  
  Log(PImage Image, int PosX, int PosY, int SizeX, int SizeY, BoilerPuzzle Parent){
    super(Image, PosX, PosY, SizeX, SizeY);
    parent = Parent;
    
  }
  
  boolean inDropOf(){
    if(posX > parent.dropOfX && posX < parent.dropOfCutX && posY > parent.dropOfY && posY < parent.dropOfCutY){
      return true;
    }
    return false;
  }
  
  void dropOf(){
    parent.logsIn += 1;
    shouldUpdate = false;
  }
}

class MatchBox extends GameObject{
  BoilerPuzzle parent;
  Match match;
  
  MatchBox(PImage Image, int PosX, int PosY, int SizeX, int SizeY, BoilerPuzzle Parent, PImage Match, PImage MatchLit){
    super(Image, PosX, PosY, SizeX, SizeY);
    parent = Parent;
    
    match = new Match(Match, MatchLit, posX, posX, Match.width, Match.height, this);
  }
  
  void update(){
    super.update();
    if(mouseOver && click){
      click = false;
      match.selected = true;
    }
    
    if(match.selected){
      match.update();
    }
  }
}

class Match extends PuzzleMoveableObject{
  MatchBox parent;
  PImage notLit;
  PImage lit;
  
  Match(PImage Image, PImage ImageLit, int PosX, int PosY, int SizeX, int SizeY, MatchBox Parent){
    super(ImageLit, PosX, PosY, SizeX, SizeY);
    notLit = Image;
    lit = ImageLit;
    parent = Parent;
  }
  
  boolean inDropOf(){
    if(posX > parent.parent.dropOfX && posX < parent.parent.dropOfCutX && posY > parent.parent.dropOfY && posY < parent.parent.dropOfCutY){
      return true;
    }
    return false;
  }
  
  void dropOf(){
    parent.parent.puzzleComplete();
  }
}

class Bucket extends PuzzleMoveableObject{
  BathroomPuzzle parent;
  
  boolean isEmpty = true;
  
  SpriteSheet sheet;
  PImage empty;
  PImage full;
  
  Bucket(PImage Image, int PosX, int PosY, int SizeX, int SizeY, BathroomPuzzle Parent){
    super(Image, PosX, PosY, SizeX, SizeY);
    sheet = new SpriteSheet(Image, 2, 1);
    empty = sheet.images[0];
    full = sheet.images[1];
    image = empty;
    parent = Parent;
  }
  
  void update(){
    super.update();
    
    if(isEmpty){
      image = empty;
    }
    else{
      image = full;
    }
    
    fillBucket();
    emptyBucket();
  }
  
  void fillBucket(){
    if(posY > parent.posY + parent.waterY && posY < parent.posY + parent.waterCutY && posX > parent.posX + parent.waterX && posX < parent.posX + parent.waterCutX && isEmpty){
      isEmpty = false;
      parent.waterLevel -= 20;
      parent.waterBuckets -= 1;
      parent.frame -= 1;
    }
  }
  
  void emptyBucket(){
    if(posX > parent.dropOfX && posX < parent.dropOfCutX && posY > parent.dropOfY && posY < parent.dropOfCutY && !isEmpty){
      isEmpty = true;
      if(parent.frame > 0){
        parent.frame -= 1;
      }
    }
  }
}

class WateringCan extends PuzzleMoveableObject{
  PImage notPooring;
  PImage pooring;
  PlantPuzzle parent;
  Bar bar;
  
  WateringCan(PImage Image, PImage ImagePooring, int PosX, int PosY, int SizeX, int SizeY, PlantPuzzle Parent){
    super(Image, PosX, PosY, SizeX, SizeY);
    notPooring = Image;
    pooring = ImagePooring;
    parent = Parent;
    bar = new Bar(posX - sizeX/2 - 50, posY, 100, 20, 100, green, "");
  }
  
  void update(){
    super.update();
    if(posX > parent.dropOfX && posX < parent.dropOfCutX && posY > parent.dropOfY && posY < parent.dropOfCutY){
      bar.posX = posX - sizeX/2 - 100;
      bar.posY = posY;
      bar.progress += 1;
      bar.update();
      image = pooring;
      sizeX = pooring.width/2;
      sizeY = pooring.height/2;
    }
    else if(bar.progress > 0){
      bar.progress -= 1;
      image = notPooring;
      sizeX = notPooring.width/2;
      sizeY = notPooring.height/2;
    }
    else{
      image = notPooring;
      sizeX = notPooring.width/2;
      sizeY = notPooring.height/2;
    }
    
    if(bar.complete){
      parent.puzzleComplete();
    }
  }
  
  
}

class Switch extends GameObject{
  SpriteSheet sprites;
  ElectricalPuzzle parent;
  boolean flicked = false;
  
  Switch(PImage Image, int PosX, int PosY, int SizeX, int SizeY, ElectricalPuzzle Parent){
    super(Image, PosX, PosY, SizeX, SizeY);
    
    sprites = new SpriteSheet(Image, 2, 1);
    parent = Parent;
  }
  
  void update(){
    super.update();
    if(flicked){
      image = sprites.images[0];
    }
    else{
      image = sprites.images[1];
    }
    
    flick();
  }
  
  void flick(){
    if(mouseOver && click){
      click = false;
      
      if(flicked){
        turnOff();
      }
      else{
        turnOn();
      }
    }
  }
  
  void turnOff(){
    if(flicked){
      parent.blackUp -= 1;
    }
    flicked = false;
  }
  
  void turnOn(){
    if(!flicked){
      parent.blackUp += 1;
    }
    flicked = true;
  }
}

class RedSwitch extends GameObject{
  ElectricalPuzzle parent;
  
  RedSwitch(PImage Image, int PosX, int PosY, int SizeX, int SizeY, ElectricalPuzzle Parent){
    super(Image, PosX, PosY, SizeX, SizeY);
    
    parent = Parent;
  }
  
  void update(){
    super.update();
    
    if(parent.blackUp == parent.blackSwitches.size() && mouseOver && click){
      click = false;
      parent.puzzleComplete();
    }
  }
}

class Plunger extends GameObject{
  PImage[] images;
  CloggedSink parent;
  Bar bar;
  
  Plunger(PImage Image, int PosX, int PosY, int SizeX, int SizeY, CloggedSink Parent){
    super(Image, PosX, PosY, SizeX, SizeY);
    SpriteSheet sheet = new SpriteSheet(Image, 2, 1);
    images = sheet.images;
    image = images[0];
    parent = Parent;
    bar = new Bar(parent.posX - 30, parent.posY + 210, 100, 20, 5, green, "");
  }
  
  boolean inDropOff(){
    if(posX > parent.dropOfX && posX < parent.dropOfCutX && posY > parent.dropOfY && posY < parent.dropOfCutY){
      return true;
    }
    return false;
  }
  
  int sinkHealth = 5;
  
  int right = 0;
  int into, dedans;
  
  boolean selected = false;
  boolean down = false;
  
  void plunging(){
    if (mouseOver == true && click == true){
      click = false;
      selected = true;
    }
    if (selected == true && mouseDown){
      posY = mouseY;
      if(mouseY - parent.posY > 135){
        posY = 135 + parent.posY;
      }
      else if(mouseY - parent.posY < -250){
        posY = parent.posY - 250;
      }
    }
    
    if(posY - parent.posY > 90){
      down = true;
      into = 1;
    }
    
    if(down && posY - parent.posY < 80){
      down = false;
      sinkHealth -= 1;
      bar.progress += 1;
    }
    /*else{
      into = 0;
      dedans = into;
    }
    
    
    if(into == 1 && into != dedans){
      down = true;
      dedans = into;
    }
    else if(down && posY < 300){
      down = false;
      sinkHealth -= 1;
      bar.progress += 1;
    }
    */
    if(sinkHealth == 0){
      parent.puzzleComplete();
    }
    
    //println(sinkHealth);
  }
  
  void update(){
    super.update();
    plunging();
    bar.update();
    
    if(down){
      image = images[1];
    }
    else{
      image = images[0];
    }
  }
  
}
